﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11
@EndOfDesignText@
#Event: TransactionStatus(Reference As String,Status As String)
#Event: TransactionResponse(Reference As String,Response As String)
#Event: Ready(Status As String)

Sub Class_Globals
	Private xui As XUI
	Private dia As B4XDialog
	Private Callback As B4XView
	Private CloseLabel As B4XView
	Private PayWebView As WebView
End Sub

'Initializes Paystack
'EventName - Event Name
'Root - Pag
'<code>
'Pay.Initialize(Root)
'</code>
Public Sub Initialize(Root As B4XView)
	Callback = Root
End Sub

Private Sub PaymentPage_PageFinished (Url As String)
	ProgressDialogHide
	If SubExists(Instance,Event&"_Ready") Then
		CallSub2(Instance,Event&"_Ready","Ready")
	End If
	Loaded = True
End Sub

Private Sub PaymentPage_ReceivedError(ErrorCode As Int, Description As String, FailingUrl As String)
	ProgressDialogHide
	If SubExists(Instance,Event&"_Ready") Then
		CallSub2(Instance,Event&"_Ready","Error")
	End If
	Loaded = False
End Sub

'Public Sub GetPublicKey As Object
'	Dim ctxt As JavaObject
'	ctxt.InitializeContext
'	Dim ApplicationInfo As JavaObject = ctxt.RunMethodJO("getPackageManager", Null).RunMethod("getApplicationInfo", _
'       Array(Application.PackageName, 0x00000080))
'	Dim bundle As JavaObject = ApplicationInfo.GetField("metaData")
'	Return bundle.RunMethod("getString", Array("co.paystack.android.PublicKey"))
'End Sub

Public Sub CancelPayment
	PaymentPage.RemoveView
End Sub

Private Sub PaymentPage_OverrideUrl (Url As String) As Boolean
	Log(Url)
	If SubExists(Instance,Event&"_Debug") Then
		CallSub2(Instance,Event&"_Debug",Url)
	End If
	If Url.Contains("api.com") Then
'		VerifyTransaction(ReferenceCode)
	End If
	Return True
End Sub

'Starts a transaction
'Email - Email of the payee
'Amount - Payment amount
'Reference - Reference of transaction
'Currency - Currency of transaction
'<code>Pay.InitializeTransaction("oxxxxx@gmail.com", 1,"test-1234",Pay.CURRENCY_USD)</code>
Public Sub InitializeTransaction(Email As String, Amount As Int,Reference As String,Label As String,Currency As String)
	Private HTML As String = $"
<!doctype html>
<html>
<head>
	<title>Paystack</title>
	<script>
		function setCookie(cname, cvalue, exdays) {
		  const d = new Date();
		  d.setTime(d.getTime() + (exdays*24*60*60*1000));
		  let expires = "expires="+ d.toUTCString();
		  document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
		}
		setCookie('SameSite', 'Secure', 1);
	</script>
	<script type="text/javascript" src="https://js.paystack.co/v1/inline.js"></script>
</head>
<body>
	<script>
		function Pay(key,email,amount,ref,label,currency){
			let handler = PaystackPop.setup({
				key: key,
				email: email,
				amount: amount * 100,
				ref: ref+Math.floor((Math.random() * 1000000000) + 1),
				label: label,
				currency: currency,
				onClose: function(){
					B4A.CallSub("Message",true,"Paystack","Payment Cancelled","cancelled");
				},
				callback: function(response){	
					if(response.status == 'success'){
						B4A.CallSub("Message",true,"Paystack","Payment of "+currency+amount+" Successul","success");
					}else{
						B4A.CallSub("Message",true,"Paystack","Error: "+response.status,"error");
					}
				}
			});
			handler.openIframe();
		}
		Pay('${PUB_KEY}','${Email}',${Amount},'${Reference}','${Label}','${Currency}');
	</script>
</script>
</body>
</html>
	"$
	If Loaded == True Then
	ReferenceCode = Reference
'		PaymentPageExtra.ExecuteJavascript("Pay('"&PUB_KEY&"','"&Email&"',"&Amount&",'"&Reference&"','"&Label&"','"&Currency&"');")
		PaymentPage.LoadHtml(HTML)
		If POPUP == False Then
			For Each v As View In Page.GetAllViewsRecursive
				If v.Visible == True Then
					v.Visible = False
				End If
			Next
			PaymentPageExtra.BringToFront
			PaymentPageExtra.Visible = True
		Else
			For Each v As View In Page.GetAllViewsRecursive
				If v.Visible == True Then
					v.Visible = False
				End If
			Next
			POPUP_PANEL.BringToFront
			POPUP_PANEL.SetVisibleAnimated(1000,True)
			PaymentPage.SetVisibleAnimated(1000,True)
		End If
		SetNavigationBarColor(Colors.RGB(189,229,244))
'	Else
'		Message("Error","Failed to load","error")
	End If
End Sub

Private Sub SetNavigationBarColor(clr As Int)
	Dim p As Phone
	If p.SdkVersion >= 21 Then  'versão 5.0
		Dim jo As JavaObject
		jo.InitializeContext
		Dim window As JavaObject = jo.RunMethodJO("getWindow", Null)
		window.RunMethod("addFlags", Array (0x80000000))
		window.RunMethod("clearFlags", Array (0x04000000))
		window.RunMethod("setNavigationBarColor", Array(clr))
		window.RunMethod("setStatusBarColor", Array(clr))
	End If
End Sub

Sub IME_HeightChanged(NewHeight As Int, OldHeight As Int)
	PaymentPage.Height = PaymentPage.Height - NewHeight
End Sub

Private Sub Message(Title As String, Text As String,State As String)
	If ShowMessage == True Then
		Msgbox2Async(Text, Title, "", "Ok", "", Application.Icon, True)
'		Msgbox2Async(Text, Title, "", "Ok", "", JarFile.LoadBitmapFromJar("paystack-logo.png"), True)
	End If
	If PaymentPage.Visible == True And POPUP == False Then
		For Each v As View In Page.GetAllViewsRecursive
			If v.Visible == False Then
				v.Visible = True
			End If
		Next
		PaymentPage.SendToBack
		PaymentPage.Visible = False
	Else If PaymentPage.Visible == True And POPUP == True Then
		For Each v As View In Page.GetAllViewsRecursive
			If v.Visible == False Then
				v.Visible = True
			End If
		Next
		POPUP_PANEL.SendToBack
		POPUP_PANEL.SetVisibleAnimated(1000,False)
	End If
	Page.Title = PageCurrentTitle
	
	If SubExists(Instance,Event&"_TransactionStatus") Then
		CallSub3(Instance,Event&"_TransactionStatus",ReferenceCode,State)
	End If
	If SubExists(Instance,Event&"_TransactionResponse") Then
		CallSub3(Instance,Event&"_TransactionResponse",ReferenceCode,State)
	End If
End Sub